/****************************************************************************/
/* RWS - beta version 0.50                                                  */
/****************************************************************************/

// RWSICON.C
// Remote Workplace Server - demo program "Iconomize" 

/****************************************************************************/

/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Remote Workplace Server - "Iconomize" demo program.
 *
 * The Initial Developer of the Original Code is Richard L. Walsh.
 * 
 * Portions created by the Initial Developer are Copyright (C) 2004
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 * ***** END LICENSE BLOCK ***** */

/****************************************************************************/
#if 0

This program demonstrates how to use RWS and employs most of its features.
It enables the user to significantly reduce the size of os2.ini by deleting
icon data that is stored there unnecessarily.

It starts by reading the list of object handles stored in PM_Abstract:Icons.
Each of these represents an abstract object whose default icon has been
replaced by a custom icon.  It then retrieves all of the object`s titles
and places them in a listbox.

When the user selects an object from the list, it retrieves and displays
the object`s current custom icon and its default icon.  It also retrieves
the path of the folder containing the object and displays the icon`s size.
Clicking MB2 on the listbox will display the object`s menu;  clicking MB2
on the folder`s path will display its menu.

If the user finds that the custom icon duplicates the default icon, s/he can
reset the object and eliminate the custom icon.  This change can be undone
until another object is selected, at which time the change becomes permanent.

#endif
/****************************************************************************/

#define INCL_DOS
#define INCL_PM
#include "RWSICON.H"
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include "..\RWS.H"
#include "..\RWSERR.H"

/****************************************************************************/

void        Morph( void);
MRESULT _System MainWndProc( HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2);
MRESULT _System LBSubProc( HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2);
MRESULT _System StaticSubProc( HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2);
BOOL    _System FindWordHook( USHORT usCodepage, PSZ pszText, ULONG cb,
                              ULONG ich, PULONG pichStart, PULONG pichEnd,
                              PULONG pichNext);
BOOL        InitDlg( HWND hwnd);
BOOL        IsRwsSrvInstalled( void);
BOOL        GetList( HWND hwnd);
ULONG       GetListItems( PRWSBLD pBld, ULONG cnt);
BOOL        ItemSelected( HWND hwnd);
ULONG       GetIcon( HWND hwnd);

ULONG       SetToDefault( void);
ULONG       SetToOriginal( void);
HPOINTER    QueryIcon( void);
ULONG       GetUndoInfo( void);
ULONG       GetUndoInfo( void);

ULONG       ResetIcon( HWND hwnd);
ULONG       UndoIcon( HWND hwnd);
ULONG       DisplayObjectMenu( HWND hwnd, MPARAM mp1);
ULONG       DisplayFolderMenu( HWND hwnd, MPARAM mp1);

/****************************************************************************/

char        szCopyright[] = "Iconomize - (C)Copyright 2004  R.L.Walsh";
BOOL        fFalse = FALSE;

// hwnds we use a lot
HWND        hLB = 0;
HWND        hCur = 0;
HWND        hDef = 0;

// original wndprocs for the listbox & folder text
PFNWP       pfnLB = 0;
PFNWP       pfnStatic = 0;

// colors for the listbox's scrollbar
ULONG       ulScrollBtn = 0x00E2E2C9;
ULONG       ulScrollBar = 0x00F5F5C9;

// icon handles for the current object
HPOINTER    hptrCurSav = 0;
HPOINTER    hptrDefSav = 0;

// size of the current icon & total bytes saved
ULONG       ulCurBytes = 0;
ULONG       ulTotBytes = 0;

// used with wpSetIconInfo() to reset an object's icon to its default
ICONINFO    iiClear = { sizeof(ICONINFO), ICON_CLEAR, 0, 0, 0, 0, 0 };

// undo info
BOOL        fWasReset = FALSE;      // have we reset the icon?
SHORT       ndxUndo = -1;           // the current listbox item
HOBJECT     hoUndo = 0;             // the current object's handle
ULONG       cbUndo = 0;             // size of the undo data
BYTE        abUndo[0x6000];         // the undo buffer (24k)

/****************************************************************************/
/****************************************************************************/

// I hope this doesn't need any explanation

int         main( void)

{
    HAB     hab = 0;
    HMQ     hmq = 0;
    HWND    hwnd = 0;
    int     nRtn = 8;
    QMSG    qmsg;

do
{
    Morph();

    hab = WinInitialize( 0);
    if (!hab)
        break;

    hmq = WinCreateMsgQueue( hab, 0);
    if (!hmq)
        break;

    hwnd = WinLoadDlg(
                HWND_DESKTOP,               //  parent-window
                NULLHANDLE,                 //  owner-window
                MainWndProc,                //  dialog proc
                NULLHANDLE,                 //  EXE module handle
                IDD_MAIN,                   //  dialog id
                NULL);                      //  pointer to create params

    if (!hwnd)
        break;

    while (WinGetMsg( hab, &qmsg, NULLHANDLE, 0, 0))
        WinDispatchMsg( hab, &qmsg);

    nRtn = 0;

} while (fFalse);

    if (nRtn)
        DosBeep( 440, 150);

    if (hwnd)
        WinDestroyWindow( hwnd);
    if (hmq)
        WinDestroyMsgQueue( hmq);
    if (hab)
        WinTerminate( hab);

    return (nRtn);
}

/****************************************************************************/

// enable this program to use PM functions
// even if it was linked or started as a VIO app

void        Morph( void)

{
    PPIB    ppib;
    PTIB    ptib;

    DosGetInfoBlocks( &ptib, &ppib);
    ppib->pib_ultype = 3;
    return;
}

/****************************************************************************/

// just your basic dialog procedure

MRESULT _System MainWndProc( HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
 
{
    switch (msg)
    {
        case WM_INITDLG:
            InitDlg( hwnd);
            break;

        // our 3 buttons
        case WM_COMMAND:
            if (SHORT1FROMMP( mp1) == IDC_GET)
                GetIcon( hwnd);
            else
            if (SHORT1FROMMP( mp1) == IDC_RESET)
                ResetIcon( hwnd);
            else
            if (SHORT1FROMMP( mp1) == IDC_UNDO)
                UndoIcon( hwnd);
            break;

        case WM_CONTROL:
            // equivalent to pressing Get when Get isn't disabled
            if (mp1 == MPFROM2SHORT( IDC_LB, LN_ENTER))
            {
                if (ItemSelected( hwnd))
                    GetIcon( hwnd);
            }
            else
            // enable/disable the Get button depending on selection
            if (mp1 == MPFROM2SHORT( IDC_LB, LN_SELECT))
                ItemSelected( hwnd);
            break;

        // defeat default button action
        case WM_CHAR:
            if (((CHARMSG(&msg)->fs & (USHORT)KC_VIRTUALKEY) &&
                   CHARMSG(&msg)->vkey == VK_ENTER) ||
                ((CHARMSG(&msg)->fs & (USHORT)KC_CHAR) &&
                   CHARMSG(&msg)->chr == '\r'))
                break;

            return (WinDefDlgProc( hwnd, msg, mp1, mp2));

        case WM_CLOSE:
            WinPostMsg( hwnd, WM_QUIT, NULL, NULL);
            break;

        // destroy the icons we've saved
        case WM_DESTROY:
            WinSendMsg( hCur, SM_SETHANDLE, 0, 0);
            WinSendMsg( hDef, SM_SETHANDLE, 0, 0);
            if (hptrCurSav)
                WinDestroyPointer( hptrCurSav);
            if (hptrDefSav)
                WinDestroyPointer( hptrDefSav);
            return (WinDefDlgProc( hwnd, msg, mp1, mp2));

        default:
            return (WinDefDlgProc( hwnd, msg, mp1, mp2));

    } //end switch (msg)

    return (0);
}

/****************************************************************************/

// subclassed solely to popup the current object's menu

MRESULT _System LBSubProc( HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
 
{
    if (msg == WM_CONTEXTMENU)
    {
        DisplayObjectMenu( hwnd, mp1);
        return ((MRESULT)TRUE);
    }

    return (pfnLB( hwnd, msg, mp1, mp2));
}

/****************************************************************************/

// subclassed solely to popup the current folder's menu

MRESULT _System StaticSubProc( HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
 
{
    if (msg == WM_CONTEXTMENU)
    {
        DisplayFolderMenu( hwnd, mp1);
        return ((MRESULT)TRUE);
    }

    return (pfnStatic( hwnd, msg, mp1, mp2));
}

/****************************************************************************/

// breaks strings into "words" using backslashes rather than spaces as the
// delimiting character;  this makes the paths displayed in IDC_INFO a bit
// more readable

BOOL    _System FindWordHook( USHORT usCodepage, PSZ pszText, ULONG cb,
                              ULONG ich, PULONG pichStart, PULONG pichEnd,
                              PULONG pichNext)

{
    ULONG   end;

    if (ich >= cb)
        end = ich;
    else
    {
        end = ich + 1;
        while (end < cb && pszText[end] != '\\')
            end++;
    }

    *pichStart = ich;
    *pichEnd = end;
    *pichNext = end;

    return (TRUE);
}

/****************************************************************************/

// init controls, init RwsClient, fill the listbox with object titles

BOOL        InitDlg( HWND hwnd)

{
    BOOL        fRtn = FALSE;
    HWND        hTmp;
    HPOINTER    hIcon;
    ULONG       rc;
    char *      pErr = 0;

do
{
    // we use these a lot
    hLB   = WinWindowFromID( hwnd, IDC_LB);
    hCur  = WinWindowFromID( hwnd, IDC_CURICON);
    hDef  = WinWindowFromID( hwnd, IDC_DEFICON);

    if (hLB == 0 || hCur == 0 || hDef == 0)
    {
        pErr = "Unable to initialize dialog!\nIconomize is disabled - please exit";
        break;
    }

    // set the dialog's icon
    hIcon = WinLoadPointer( HWND_DESKTOP, 0, IDI_RWSICON);
    if (hIcon)
        WinSendMsg( hwnd, WM_SETICON, (MP)hIcon, 0);

    // disable these buttons until we have an object to mess with
    WinEnableControl( hwnd, IDC_RESET, FALSE);
    WinEnableControl( hwnd, IDC_UNDO, FALSE);

    // set the colors for the listbox's scrollbar (these are the
    // only colors that can't be set in the dialog template)
    hTmp = WinQueryWindow( hLB, QW_TOP);
    if (hTmp)
    {
        WinSetPresParam( hTmp, PP_HILITEFOREGROUNDCOLOR,
                         sizeof( ulScrollBtn), &ulScrollBtn);
        WinSetPresParam( hTmp, PP_FOREGROUNDCOLOR,
                         sizeof( ulScrollBar), &ulScrollBar);
    }

    // set a wordbreak hook that will parse the paths shown in IDC_INFO
    if (WinSetHook( 0, HMQ_CURRENT, HK_FINDWORD, (PFN)&FindWordHook, 0) == FALSE)
        printf( "failed to install FindWord hook\n");

    if (IsRwsSrvInstalled() == FALSE)
    {
        printf( "IsRwsSrvInstalled failed\n");
        pErr = "Unable to locate RWS WPS class!\nIconomize is disabled - please exit";
        break;
    }

    // init RwsClient which may in turn init RwsServer
    rc = RwsClientInit();
    if (rc)
    {
        printf( "RwsClientInit failed - rc= %d\n", rc);
        pErr = "Unable to initialize server!\nIconomize is disabled - please exit";
        break;
    }

    // fill the listbox with the objects in PM_Abstract:Icons
    if (GetList( hwnd) == FALSE)
    {
        pErr = "Unable to list objects!\nIconomize is disabled - please exit";
        break;
    }

    // subclass the listbox & folder text so we can popup menus
    pfnLB = WinSubclassWindow( hLB, &LBSubProc);
    if (pfnLB == 0)
        printf( "WinSubclassWindow failed for IDC_LB\n");

    hTmp = WinWindowFromID( hwnd, IDC_INFO);
    pfnStatic = WinSubclassWindow( hTmp, &StaticSubProc);
    if (pfnStatic == 0)
        printf( "WinSubclassWindow failed for IDC_INFO\n");

    fRtn = TRUE;

} while (fFalse);

    // if an error occured, show a msg & disable the Get button
    if (pErr)
    {
        WinSetDlgItemText( hwnd, IDC_INFO, pErr);
        WinEnableControl( hwnd, IDC_GET, FALSE);
    }

    return (fRtn);
}

/****************************************************************************/

// if the RWS class isn't already registered, try to locate & register it

BOOL        IsRwsSrvInstalled( void)

{
    BOOL        fRtn = FALSE;
    ULONG       ulSize;
    char *      pBuf = 0;
    POBJCLASS   ptr;

do
{
    // see how much space the class list requires
    if (WinEnumObjectClasses( NULL, &ulSize) == FALSE)
        break;

    // alloc a buffer
    pBuf = (char*)malloc( ulSize);
    if (pBuf == 0)
        break;

    // get the class list
    if (WinEnumObjectClasses( (POBJCLASS)pBuf, &ulSize) == FALSE)
        break;

    // look for RWS
    for (ptr = (POBJCLASS)pBuf; ptr; ptr = ptr->pNext)
        if (strcmp( ptr->pszClassName, RWSCLASSNAME) == 0)
        {
            fRtn = TRUE;
            break;
        }

    // if found, exit
    if (fRtn)
        break;

    // if the server dll is in the current directory, we must register
    // it using a f/q name because this directory probably isn't listed
    // in LIBPATH, so search the current directory & the PATH first;
    // if that fails, try to register it using just the module name
    // which will cause an implicit search of LIBPATH
    if (DosSearchPath( SEARCH_ENVIRONMENT | SEARCH_CUR_DIRECTORY,
                       "PATH", RWSSRVDLL, pBuf, ulSize))
    {
        printf( "unable to locate" RWSSRVDLL "- using modname\n");
        strcpy( pBuf, RWSSRVMOD);
    }

    // if WinRegisterObjectClass() returns FALSE, it means the dll couldn't
    // be found;  however the class still gets added to the class list, so
    // we have to explicitly remove it to avoid future registration failures
    if (WinRegisterObjectClass( RWSCLASSNAME, pBuf) == FALSE)
    {
        printf( "WinRegisterObjectClass failed - deregistering\n");
        WinDeregisterObjectClass( RWSCLASSNAME);
        break;
    }

    fRtn = TRUE;

} while (fFalse);

    free( (PVOID)pBuf);

    return (fRtn);
}

/****************************************************************************/

// Fill the listbox with the titles of the objects in PM_Abstract:Icons.
// This function, along with GetListItems() demonstrates the use of
// RWS's object conversion feature.  It also demonstrates how to use
// RwsCallIndirect() to avoid pushing large numbers of arguments onto
// the stack.  Note that some errors here are considered critical and
// abort the procedure while others simply produce warnings to the user.

BOOL        GetList( HWND hwnd)

{
    BOOL        fRtn = FALSE;
    ULONG       rc = 0;
    ULONG       ctr;
    PRWSARG     pArg;
    PRWSBLD     pBld = 0;
    char *  	pMem = 0;
    char *      ptr;

do
{
    // clear out the listbox
    WinSendMsg( hLB, LM_DELETEALL, 0, 0);

    // see how large the list of object handles is
    if (PrfQueryProfileSize( HINI_USERPROFILE, "PM_Abstract:Icons",
                             0, &ctr) == FALSE)
        ERRNBR( 1)

    // get some mem to hold the list
    pMem = (char*)malloc( ctr);
    if (pMem == 0)
        ERRNBR( 2)

    // get the list of object handles
    if (PrfQueryProfileData( HINI_USERPROFILE, "PM_Abstract:Icons",
                             0, pMem, &ctr) == FALSE)
        ERRNBR( 3)

    // we're going to convert object handles into object titles
    // in batches of 16, so allocate enough mem to hold one RWSBLD
    // struct & an array of 16 RWSARG structs
    ctr = sizeof( RWSBLD) + 16*sizeof( RWSARG);
    pBld = (PRWSBLD)malloc( ctr);
    if (pBld == 0)
        ERRNBR( 4)

    // clear the mem, then fill in the fields that will be constant
    memset( pBld, 0, ctr);
    pBld->callType = RWSP_CONV;                 // data conversion call
    pBld->rtnType = RWSR_ASIS;                  // returns the nbr of conversions
    for (ctr=0, pArg=CALCARGPTR( pBld); ctr < 16; ctr++)
        pArg[ctr].type = RWSC_OHNDL_OTITLE;     // obj handle to obj title

    // step thru the list of object handles;  a null string signals the end
    for (ptr=pMem, ctr=0, pArg=CALCARGPTR( pBld); *ptr; ptr=strchr( ptr, 0)+1)
    {
        // convert the string into the handle of an Abstract object
        // and store it in the value field of the current RWSARG
        pArg[ctr].value = strtoul( ptr, 0, 16);
        if (pArg[ctr].value == 0)
            continue;
        pArg[ctr].value += 0x20000;
        ctr++;

        // if we now have 16 entries, get their titles
        // and put them in the listbox
        if (ctr >= 16)
        {
            if (GetListItems( pBld, ctr))
                rc = 5;
            ctr = 0;
        }
    }

    // handle the final batch of entries
    if (ctr)
        if (GetListItems( pBld, ctr))
            rc = 5;

    fRtn = TRUE;

} while (fFalse);

    // free our memory
    free( pMem);
    free( pBld);

    if (rc)
    {
        // display any error on the console
        printf( "GetList:  rc= %d  fRtn= %s\n",
                rc, (fRtn ? "true" : "false"));

        // for non-critical errors, warn the user
        if (fRtn)
            WinSetDlgItemText( hwnd, IDC_INFO,
                               "Error!  Some objects with icons are not listed.");
    }

    return (fRtn);
}

/****************************************************************************/

// Converts up to 16 object handles into object titles, then inserts
// those handles & titles into a listbox.  This function demonstrates
// the use of RwsCallIndirect() which takes a ptr to an RWSBLD struct
// followed by an array of RWSARG structs.  If we were using RwsCall(),
// we'd have to push *54* arguments onto the stack instead of just one.

ULONG       GetListItems( PRWSBLD pBld, ULONG cnt)

{
    ULONG       rc = 0;
    ULONG       rc2 = 0;
    ULONG       ctr;
    PRWSDSC     pDsc;
    PRWSHDR     pHdr = 0;
    char *      ptr;
    SHORT       ndx;

do
{
    // identify the number of args (extra RWSARG structs will be ignored)
    pBld->argCnt = cnt;

    // provide a place to store a ptr to the final results
    pBld->ppHdr = &pHdr;

    // have RwsClient construct a server request block then dispatch it
    // to RwsServer;  on a successful return, pHdr will point at that
    // request block which will contain both the data we passed in and
    // the data returned by the server;  note that for object conversions,
    // some can fail without the entire call failing
    ERRRTN( RwsCallIndirect( pBld))

    // go thru the results, extracting both the object handle
    // we supplied and the object title returned by the server;
    // if there's an error, we'll note it but won't abort
    for (ctr=0; ctr < cnt; ctr++)
    {
        // get a ptr to the current item in the request block;  note
        // that arguments numbers start at 1 - arg0 is the return;
        // also, if we only needed the results (the object title)
        // and not the handle we provided, we could use RwsGetResult()
        rc2 = RwsGetArgPtr( pHdr, ctr+1, &pDsc);
        if (rc2)
            break;

        // if the rc field for this item is non-zero, then the
        // conversion failed;  note it but continue because the
        // other conversions probably succeeded
        if (pDsc->rc)
        {
            rc2 = 1;
            continue;
        }

        // this points at the output buffer (i.e. the title string)
        ptr = (char*)pDsc->pget;
        if (ptr == 0)
        {
            rc2 = 2;
            continue;
        }

        // get rid of carriage returns, line feeds, and carets
        while ((ptr = strpbrk( ptr, "\r\n^")) != 0)
            *ptr = ' ';

        // insert the title
        ndx = (SHORT)(ULONG)WinSendMsg( hLB, LM_INSERTITEM,
                            (MP)LIT_SORTASCENDING, (MP)pDsc->pget);
        if (ndx < 0)
        {
            rc2 = 3;
            continue;
        }

        // add the original object handle to this list item;
        // it is stored in an input buffer located immediately
        // after this arg's RWSDSC struct (i.e. at pDsc[1])
        if (WinSendMsg( hLB, LM_SETITEMHANDLE, (MP)ndx,
                        (MP)*(PULONG)CALCGIVEPTR( pDsc)) == 0)
        {
            rc2 = 4;
            // if we couldn't set the handle, delete this item
            WinSendMsg( hLB, LM_DELETEITEM, (MP)ndx, 0);
        }
    }

    rc = rc2;

} while (fFalse);

    // free the request block RwsClient allocated on our behalf
    RwsFreeMem( pHdr);

    if (rc)
        printf( "GetListItems:  rc= %d\n", rc);

    return (rc);
}

/****************************************************************************/

// after the user presses the Reset button, we disable the Get button
// to avoid accidentally making the change permanent;  when the selection
// changes to a different item, we reenable Get

BOOL        ItemSelected( HWND hwnd)

{
    BOOL        fRtn = TRUE;
    ULONG   	rc = 0;
    SHORT       ndx;

do
{
    // if the icon hasn't been reset, no problem so exit
    if (fWasReset == FALSE)
        break;

    // get the new selection
    ndx = (SHORT)(ULONG)WinSendMsg( hLB, LM_QUERYSELECTION,
                                    MPFROMSHORT( LIT_FIRST), 0);
    if (ndx < 0)
        ERRNBR( 1)

    // enable/disable the Get button depending on whether
    // the new selection is the one previously reset
    fRtn = (ULONG)(ndx != ndxUndo);
    WinEnableControl( hwnd, IDC_GET, fRtn);

} while (fFalse);

    if (rc)
        printf( "ItemSelected:  rc= %d\n", rc);

    return (fRtn);
}

/****************************************************************************/

// This is the program's core function.  For each new selection, it destroy's
// the previous selection's icons, then fetches the new object's custom and
// default icons.  If only it were that simple...  To get the default icon,
// it has to save the current icon's data, temporarily reset the object to
// its default, fetch that icon handle, then restore the original icon.
// Most of the dirty work is handled by subfunctions.

ULONG       GetIcon( HWND hwnd)

{
    ULONG   	rc = 0;
    ULONG       ulObj;
    HPOINTER    hptrCur;
    HPOINTER    hptrDef;
    PRWSHDR     pHdr = 0;
    char *      ptr;
    SHORT       ndx;
    char        szText[CCHMAXPATH];

do
{
    // identify the current selection
    ndx = (SHORT)(ULONG)WinSendMsg( hLB, LM_QUERYSELECTION,
                                    MPFROMSHORT( LIT_FIRST), 0);
    if (ndx < 0)
        ERRNBR( 1)

    // get its object handle
    ulObj = (ULONG)WinSendMsg( hLB, LM_QUERYITEMHANDLE, (MP)ndx, 0);
    if (ulObj == 0)
        ERRNBR( 2)

    // get the folder this object is in & convert it to a f/q path;
    // beside providing useful info, this also confirms the object
    // handle is still valid
    ERRRTN( RwsCall( &pHdr, RWSP_MNAM, (ULONG)"wpQueryFolder",
                            RWSR_OPATH, 0, 1,
                            RWSI_OHNDL, 0, ulObj))

    // retrieve a ptr to the path that was returned
    ptr = (char*)RwsGetResult( pHdr, 0, 0);
    if ((ULONG)ptr == (ULONG)-1)
        ERRNBR( 5)

    // get the object's title
    WinSendMsg( hLB, LM_QUERYITEMTEXT,
                MPFROM2SHORT( ndx, sizeof(szText)), (MP)szText);

    // display the title & path
    WinSetDlgItemText( hwnd, IDC_CUROBJ, szText);
    WinSetDlgItemText( hwnd, IDC_INFO, ptr);

    // free the server request block
    RwsFreeMem( pHdr);
    pHdr = 0;

    // enable/disable buttons to match the current state
    WinEnableControl( hwnd, IDC_GET, TRUE);
    WinEnableControl( hwnd, IDC_RESET, FALSE);
    WinEnableControl( hwnd, IDC_UNDO, FALSE);
    WinSetDlgItemText( hwnd, IDC_DEFFRAME, "Default");

    // if the selection we left had its icon reset to the default,
    // this will make the change permanent, so delete that item
    // and update the total bytes freed counter
    if (fWasReset)
    {
        ulTotBytes += ulCurBytes;
        sprintf( szText, "%d", ulTotBytes);
        WinSetDlgItemText( hwnd, IDC_BYTESTOT, szText);
        WinSendMsg( hLB, LM_DELETEITEM, (MP)ndxUndo, 0);
        if (ndx > ndxUndo)
            ndx--;
        fWasReset = FALSE;
    }

    ndxUndo = ndx;
    hoUndo = ulObj;
    cbUndo = 0;
    ulCurBytes = 0;
    WinSetDlgItemText( hwnd, IDC_BYTESCUR, "0");

    // destroy the icon handles we saved & remove them from the display
    WinSendMsg( hCur, SM_SETHANDLE, 0, 0);
    WinInvalidateRect( WinWindowFromID( hwnd, IDC_CURBKGND), NULL, FALSE);
    if (hptrCurSav)
        if (WinDestroyPointer( hptrCurSav) == FALSE)
            printf( "GetIcon:  WinDestroyPointer failed - hptr= %x\n", hptrCurSav);
    hptrCurSav = 0;

    WinSendMsg( hDef, SM_SETHANDLE, 0, 0);
    WinInvalidateRect( WinWindowFromID( hwnd, IDC_DEFBKGND), NULL, FALSE);
    if (hptrDefSav)
        if (WinDestroyPointer( hptrDefSav) == FALSE)
            printf( "GetIcon:  WinDestroyPointer failed - hptr= %x\n", hptrDefSav);
    hptrDefSav = 0;

    // get the object's current icon
    hptrCur = QueryIcon();
    if (hptrCur == 0)
        ERRNBR( 6)

    // save it, display it
    hptrCurSav = hptrCur;
    WinSendMsg( hCur, SM_SETHANDLE, (MP)hptrCur, 0);

    // get the info we'll need to restore the current icon
    if (GetUndoInfo())
        ERRNBR( 7)

    // reset the object to its default icon
    if (SetToDefault())
        ERRNBR( 8)

    // get the default icon's handle
    hptrDef = QueryIcon();

    // if that failed, restore the original, then exit;
    if (hptrDef == 0)
    {
        rc = 9;
        // calling SetToOriginal() here allows us to
        // pinpoint what failures occurred and where
        if (SetToOriginal())
            rc = 10;
        break;
    }

    // restore the original
    if (SetToOriginal())
        ERRNBR( 11)

    // save the handle, display it
    hptrDefSav = hptrDef;
    WinSendMsg( hDef, SM_SETHANDLE, (MP)hptrDef, 0);

    // show the size of the current icon
    sprintf( szText, "%d", ulCurBytes);
    WinSetDlgItemText( hwnd, IDC_BYTESCUR, szText);

    // now that we have the default icon, enable the Reset button
    WinEnableControl( hwnd, IDC_RESET, TRUE);

} while (fFalse);

    // free the server request block
    RwsFreeMem( pHdr);

    if (rc)
        printf( "GetIcon:  rc= %d\n", rc);

    return (rc);
}

/****************************************************************************/

// resets the object to its default icon;
// demonstrates calling a method by name

ULONG       SetToDefault( void)

{
    ULONG   	rc = 0;
    PRWSHDR     pHdr = 0;

do
{
    // if we don't have the info to undo this, don't do this
    if (hoUndo == 0 || cbUndo == 0)
        ERRNBR( 1)

    // equivalent to _wpSetIconData( somSelf, &iiClear);
    ERRRTN( RwsCall( &pHdr, RWSP_MNAM, (ULONG)"wpSetIconData",
                            RWSR_ASIS, 0, 2,
                            RWSI_OHNDL, 0, hoUndo,
                            RWSI_PBUF, sizeof( iiClear), (ULONG)&iiClear))

} while (fFalse);

    // free the server request block
    RwsFreeMem( pHdr);

    if (rc)
        printf( "SetToDefault:  rc= %d\n", rc);

    return (rc);
}

/****************************************************************************/

// Restores the object to its custom icon.  Demonstrates a situation
// where you'd need to call RwsBuild() and RwsDispatch separately
// rather than using RwsCall().  In this case, the pIconData member
// of the saved ICONINFO struct must be adjusted to point at the
// current location of that data within the server request block.

ULONG       SetToOriginal( void)

{
    ULONG   	rc = 0;
    PRWSHDR     pHdr = 0;
    ICONINFO *  ptr;

do
{
    // if we don't have the info to undo this, don't do this
    if (hoUndo == 0 || cbUndo == 0)
        ERRNBR( 1)

    // construct a request block but don't dispatch it
    ERRRTN( RwsBuild( &pHdr, RWSP_MNAM, (ULONG)"wpSetIconData",
                             RWSR_ASIS, 0, 2,
                             RWSI_OHNDL, 0, hoUndo,
                             RWSI_PBUF, cbUndo, (ULONG)abUndo))

    // get a ptr the ICONINFO struct in arg2
    ptr = (ICONINFO*)RwsGetResult( pHdr, 2, 0);
    if ((ULONG)ptr == (ULONG)-1)
        ERRNBR( 2)

    // when this info was saved, the existing pIconData was changed
    // from a ptr to an offset from the start of the structure;
    // now we have to add the current ICONINFO* to it to change
    // it back to a pointer
    ptr->pIconData = (PVOID)((ULONG)ptr + (ULONG)ptr->pIconData);

    // dispatch the request to the server
    ERRRTN( RwsDispatch( pHdr))

} while (fFalse);

    // free the server request block
    RwsFreeMem( pHdr);

    if (rc)
        printf( "SetToOriginal:  rc= %d\n", rc);

    return (rc);
}

/****************************************************************************/

// gets whatever is the current icon (custom or default)

HPOINTER    QueryIcon( void)

{
    ULONG   	rc = 0;
    PRWSHDR     pHdr = 0;
    HPOINTER    hRtn = 0;

do
{
    // we could have called wpQueryIcon() but this is more efficient
    // because RwsServer doesn't have to lookup the method by name
    ERRRTN( RwsCall( &pHdr, RWSP_CONV, 0,
                            RWSR_ASIS, 0, 1,
                            RWSC_OHNDL_OICON, 0, hoUndo))

    // get the result for arg1 (i.e. the icon)
    hRtn = RwsGetResult( pHdr, 1, 0);
    if (hRtn == (ULONG)-1)
    {
        hRtn = 0;
        rc = 1;
    }

} while (fFalse);

    // free the server request block
    RwsFreeMem( pHdr);

    if (rc)
        printf( "QueryIcon:  rc= %d\n", rc);

    return (hRtn);
}

/****************************************************************************/

// Get and save the ICONINFO struct & data that describes the custom icon.
// Demonstrates how an argument that a function considers to be In/Out is
// considered In-only by RWS.  Before it calls wpQueryIconData(), RWS has
// to provide a buffer to hold the returned data and pass a ptr to it in
// arg2.  After the call, RWS doesn't have to do anything (e.g. copy or
// convert the result), so from its perspective, this ptr is in-only.

ULONG       GetUndoInfo( void)

{
    ULONG   	rc = 0;
    PRWSHDR     pHdr = 0;
    ICONINFO *  ptr;

do
{
    // note:  the return value for wpQueryIconData() is worthless;
    // it should be the total bytes copied but WPProgram always
    // returns 64k
    ERRRTN( RwsCall( &pHdr, RWSP_MNAM, (ULONG)"wpQueryIconData",
                            RWSR_ASIS, 0, 2,
                            RWSI_OHNDL, 0, hoUndo,
                            RWSI_PBUF, sizeof( abUndo), 0))

    // get the ptr to the ICONINFO that RwsServer put in arg2
    ptr = (ICONINFO*)RwsGetResult( pHdr, 2, 0);
    if ((ULONG)ptr == (ULONG)-1)
        ERRNBR( 1)

    // calc the total size to be saved (ICONINFO+data)
    cbUndo = (ULONG)ptr->pIconData - (ULONG)ptr;

    // pIconData contains a linear address that's valid now but won't
    // be if the structure & data are copied to another location;
    // deal with this by changing it from a ptr to an offset from the
    // beginning of the ICONINFO struct;  SetToOriginal() converts
    // this offset back to a ptr before call wpSetIconData()
    ptr->pIconData = (PVOID)cbUndo;
    cbUndo += ptr->cbIconData;

    // if the total size is greater than the undo buffer, exit
    if (cbUndo > sizeof( abUndo))
        ERRNBR( 2)

    // save the info
    memcpy( abUndo, (PBYTE)ptr, cbUndo);

    // save the size of the icon so we can display it
    ulCurBytes = ptr->cbIconData;

} while (fFalse);

    // free the server request block
    RwsFreeMem( pHdr);

    if (rc)
        printf( "GetUndoInfo:  rc= %d\n", rc);

    return (rc);
}

/****************************************************************************/

// called when the Reset button is pushed;  it sets the object's icon to
// its default, then updates the display and enables/disables the buttons

ULONG       ResetIcon( HWND hwnd)

{
    ULONG   	rc = 0;

do
{
    // move the selection back to the current object
    WinSendMsg( hLB, LM_SELECTITEM, (MP)ndxUndo, (MP)TRUE);

    // reset the object's icon to its default
    if (SetToDefault())
        ERRNBR( 1)

    // note the reset
    fWasReset = TRUE;

    // revise the icon display
    WinInvalidateRect( WinWindowFromID( hwnd, IDC_CURBKGND), NULL, FALSE);
    WinSendMsg( hCur, SM_SETHANDLE, (MP)hptrDefSav, 0);
    WinInvalidateRect( WinWindowFromID( hwnd, IDC_DEFBKGND), NULL, FALSE);
    WinSendMsg( hDef, SM_SETHANDLE, (MP)hptrCurSav, 0);
    WinSetDlgItemText( hwnd, IDC_DEFFRAME, "Previous");

    // set buttons accordingly
    WinEnableControl( hwnd, IDC_GET, FALSE);
    WinEnableControl( hwnd, IDC_RESET, FALSE);
    WinEnableControl( hwnd, IDC_UNDO, TRUE);


} while (fFalse);

    if (rc)
        printf( "ResetIcon:  rc= %d\n", rc);

    return (rc);
}

/****************************************************************************/

// called when the Undo button is pressed, it restores the custom icon,
// then updates the display and enables/disables the buttons

ULONG       UndoIcon( HWND hwnd)

{
    ULONG   	rc = 0;

do
{
    // move the selection back to the current object
    WinSendMsg( hLB, LM_SELECTITEM, (MP)ndxUndo, (MP)TRUE);

    // reset the object to use its custom icon
    if (SetToOriginal())
        ERRNBR( 1)

    // cancel the reset
    fWasReset = FALSE;

    // revise the icon display
    WinInvalidateRect( WinWindowFromID( hwnd, IDC_CURBKGND), NULL, FALSE);
    WinSendMsg( hCur, SM_SETHANDLE, (MP)hptrCurSav, 0);
    WinInvalidateRect( WinWindowFromID( hwnd, IDC_DEFBKGND), NULL, FALSE);
    WinSendMsg( hDef, SM_SETHANDLE, (MP)hptrDefSav, 0);
    WinSetDlgItemText( hwnd, IDC_DEFFRAME, "Default");

    // set buttons accordingly
    WinEnableControl( hwnd, IDC_GET, TRUE);
    WinEnableControl( hwnd, IDC_RESET, TRUE);
    WinEnableControl( hwnd, IDC_UNDO, FALSE);

} while (fFalse);

    if (rc)
        printf( "UndoIcon:  rc= %d\n", rc);

    return (rc);
}

/****************************************************************************/

// displays the current object's popup menu;  demonstrates the only
// command that RWS currently supports

ULONG       DisplayObjectMenu( HWND hwnd, MPARAM mp1)

{
    ULONG       rc = 0;
    POINTL      ptl;
    PRWSHDR     pHdr = 0;

do
{
    // if no object has been selected, exit
    if (hoUndo == 0)
        ERRNBR( 1)

    // get the location of the mouse (in window coordinates)
    ptl.x = SHORT1FROMMP( mp1);
    ptl.y = SHORT2FROMMP( mp1);

    // this command calls wpDisplayMenu() with the "important" arguments
    // preset by RwsServer;  hwnd is the window that should get the focus
    // when the menu is dismissed, and ptl is the menu location in hwnd
    // coordinates - both arguments are optional;  the command returns
    // the popupmenu's hwnd which we don't use here
    ERRRTN( RwsCall( &pHdr, RWSP_CMD, RWSCMD_POPUPMENU,
                            RWSR_ASIS, 0, 3,
                            RWSI_OHNDL, 0, hoUndo,
                            RWSI_ASIS, 0, hwnd,
                            RWSI_PBUF, sizeof(POINTL), (ULONG)&ptl))

} while (fFalse);

    // free the server request block
    RwsFreeMem( pHdr);

    if (rc)
        printf( "DisplayObjectMenu:  rc= %d\n", rc);

    return (rc);
}

/****************************************************************************/

// displays the menu for the folder containing the current object;
// demonstrates the only command that RWS currently supports

ULONG       DisplayFolderMenu( HWND hwnd, MPARAM mp1)

{
    ULONG       rc = 0;
    POINTL      ptl;
    PRWSHDR     pHdr = 0;
    char        szText[CCHMAXPATH];

do
{
    // if no object has been selected, exit
    if (hoUndo == 0)
        ERRNBR( 1)

    // get the location of the mouse (in window coordinates)
    ptl.x = SHORT1FROMMP( mp1);
    ptl.y = SHORT2FROMMP( mp1);

    // map them to the listbox because we're going to give it the focus
    if (WinMapWindowPoints( hwnd, hLB, &ptl, 1) == FALSE)
        ERRNBR( 2)

    if (WinQueryWindowText( hwnd, sizeof( szText), szText) == 0)
        ERRNBR( 3)

    // this command calls wpDisplayMenu() with the "important" arguments
    // preset by RwsServer;  hwnd is the window that should get the focus
    // when the menu is dismissed, and ptl is the menu location in hwnd
    // coordinates - both arguments are optional;  the command returns
    // the popupmenu's hwnd which we don't use here
    ERRRTN( RwsCall( &pHdr, RWSP_CMD, RWSCMD_POPUPMENU,
                            RWSR_ASIS, 0, 3,
                            RWSI_ONAME, 0, szText,
                            RWSI_ASIS, 0, hLB,
                            RWSI_PBUF, sizeof(POINTL), (ULONG)&ptl))

} while (fFalse);

    // free the server request block
    RwsFreeMem( pHdr);

    if (rc)
        printf( "DisplayFolderMenu:  rc= %d\n", rc);

    return (rc);
}

/****************************************************************************/

