/****************************************************************************/
/* RWS - beta version 0.50                                                  */
/****************************************************************************/

// RWSSRV.H
// Remote Workplace Server - Server header

/****************************************************************************/

/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Remote Workplace Server - Server component.
 *
 * The Initial Developer of the Original Code is Richard L. Walsh.
 * 
 * Portions created by the Initial Developer are Copyright (C) 2004
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 * ***** END LICENSE BLOCK ***** */

/****************************************************************************/

#define INCL_DOS
#define INCL_PM
#include <os2.h>
#include <string.h>
#include <wpabs.h>
#include <wpclsmgr.h>
#include <wpdesk.h>
#include <wpfsys.h>
#include <wpshadow.h>
#include <wptrans.h>
#include "..\RWS.H"
#include "..\RWSERR.H"

/****************************************************************************/

// Macros & typedefs

// a generic typedef for a function that takes one or more arguments
typedef ULONG _System _RWSPROC( ULONG, ...);
typedef _RWSPROC *PFNRWSPROC;

// a generic typedef for a function that takes no arguments
typedef ULONG _System _RWSPROCV( void);
typedef _RWSPROCV *PFNRWSPROCV;

// flags that are currently used only by RWSCMD_POPUPMENU
#define RWSF_NOFREE         0x40000000UL
#define RWSF_NOREPLY        0x80000000UL

// used to generate an atom that's used as a msg to the menu host window
#define RWSMNUSTRING    "RWSMNU"

// alternate implementations of these macros
#ifdef LOUSHORT
    #undef LOUSHORT
#endif
#define LOUSHORT(l)     (((PUSHORT)(PVOID)&(l))[0])

#ifdef HIUSHORT
    #undef HIUSHORT
#endif
#define HIUSHORT(l)     (((PUSHORT)(PVOID)&(l))[1])

// my favorite macro
#define MP      MPARAM

/****************************************************************************/

// shared global data (defined in RWSINIT.C)

extern BOOL             fFalse;
extern HMODULE          hmodSOM;
extern PID              pidWPS;

extern SOMClass *       clsSOMClass;
extern SOMClass *       clsWPAbstract;
extern SOMClass *       clsWPDesktop;
extern SOMClass *       clsWPFileSystem;
extern SOMClass *       clsWPShadow;
extern SOMClass *       clsWPTransient;

/****************************************************************************/

// undocumented PM API function

HMQ     APIENTRY WinQueueFromID( HAB hab, USHORT pid, USHORT tid);

// in RWSSRV.C
ULONG           Resolve( PRWSHDR pHdr, HWND hReply);
ULONG           ResolveArgIn( PRWSDSC pArg,  PRWSDSC pArg1);

// in RWSSUTIL.C
ULONG           Cmd_PopupMenu( PRWSHDR pHdr, HWND hReply);

/****************************************************************************/

